from .const import LOGGER as LOGGER
from .entity import MatterEntity as MatterEntity
from .helpers import get_matter as get_matter
from .models import MatterDiscoverySchema as MatterDiscoverySchema
from .util import convert_to_hass_hs as convert_to_hass_hs, convert_to_hass_xy as convert_to_hass_xy, convert_to_matter_hs as convert_to_matter_hs, convert_to_matter_xy as convert_to_matter_xy, renormalize as renormalize
from _typeshed import Incomplete
from enum import IntFlag
from homeassistant.components.light import ATTR_BRIGHTNESS as ATTR_BRIGHTNESS, ATTR_COLOR_TEMP as ATTR_COLOR_TEMP, ATTR_HS_COLOR as ATTR_HS_COLOR, ATTR_XY_COLOR as ATTR_XY_COLOR, ColorMode as ColorMode, LightEntity as LightEntity, LightEntityDescription as LightEntityDescription
from homeassistant.config_entries import ConfigEntry as ConfigEntry
from homeassistant.const import Platform as Platform
from homeassistant.core import HomeAssistant as HomeAssistant, callback as callback
from homeassistant.helpers.entity_platform import AddEntitiesCallback as AddEntitiesCallback
from typing import Any

COLOR_MODE_MAP: Incomplete

async def async_setup_entry(hass: HomeAssistant, config_entry: ConfigEntry, async_add_entities: AddEntitiesCallback) -> None: ...

class MatterLight(MatterEntity, LightEntity):
    entity_description: LightEntityDescription
    @property
    def supports_color(self) -> bool: ...
    @property
    def supports_color_temperature(self) -> bool: ...
    @property
    def supports_brightness(self) -> bool: ...
    async def _set_xy_color(self, xy_color: tuple[float, float]) -> None: ...
    async def _set_hs_color(self, hs_color: tuple[float, float]) -> None: ...
    async def _set_color_temp(self, color_temp: int) -> None: ...
    async def _set_brightness(self, brightness: int) -> None: ...
    def _get_xy_color(self) -> tuple[float, float]: ...
    def _get_hs_color(self) -> tuple[float, float]: ...
    def _get_color_temperature(self) -> int: ...
    def _get_brightness(self) -> int: ...
    def _get_color_mode(self) -> ColorMode: ...
    async def send_device_command(self, command: Any) -> None: ...
    async def async_turn_on(self, **kwargs: Any) -> None: ...
    async def async_turn_off(self, **kwargs: Any) -> None: ...
    _attr_supported_color_modes: Incomplete
    _attr_color_mode: Incomplete
    _attr_hs_color: Incomplete
    _attr_xy_color: Incomplete
    _attr_color_temp: Incomplete
    _attr_is_on: Incomplete
    _attr_brightness: Incomplete
    def _update_from_device(self) -> None: ...

class ColorCapabilities(IntFlag):
    kHueSaturationSupported: int
    kEnhancedHueSupported: int
    kColorLoopSupported: int
    kXYAttributesSupported: int
    kColorTemperatureSupported: int

DISCOVERY_SCHEMAS: Incomplete
