from ..filters import Filters
from .const import NEED_ATTRIBUTE_DOMAINS as NEED_ATTRIBUTE_DOMAINS, SIGNIFICANT_DOMAINS as SIGNIFICANT_DOMAINS
from collections.abc import MutableMapping
from datetime import datetime
from homeassistant.core import HomeAssistant, State
from sqlalchemy.orm.session import Session
from typing import Any

def get_full_significant_states_with_session(hass: HomeAssistant, session: Session, start_time: datetime, end_time: datetime | None = ..., entity_ids: list[str] | None = ..., filters: Filters | None = ..., include_start_time_state: bool = ..., significant_changes_only: bool = ..., no_attributes: bool = ...) -> MutableMapping[str, list[State]]: ...
def get_last_state_changes(hass: HomeAssistant, number_of_states: int, entity_id: str) -> MutableMapping[str, list[State]]: ...
def get_significant_states(hass: HomeAssistant, start_time: datetime, end_time: datetime | None = ..., entity_ids: list[str] | None = ..., filters: Filters | None = ..., include_start_time_state: bool = ..., significant_changes_only: bool = ..., minimal_response: bool = ..., no_attributes: bool = ..., compressed_state_format: bool = ...) -> MutableMapping[str, list[State | dict[str, Any]]]: ...
def get_significant_states_with_session(hass: HomeAssistant, session: Session, start_time: datetime, end_time: datetime | None = ..., entity_ids: list[str] | None = ..., filters: Filters | None = ..., include_start_time_state: bool = ..., significant_changes_only: bool = ..., minimal_response: bool = ..., no_attributes: bool = ..., compressed_state_format: bool = ...) -> MutableMapping[str, list[State | dict[str, Any]]]: ...
def state_changes_during_period(hass: HomeAssistant, start_time: datetime, end_time: datetime | None = ..., entity_id: str | None = ..., no_attributes: bool = ..., descending: bool = ..., limit: int | None = ..., include_start_time_state: bool = ...) -> MutableMapping[str, list[State]]: ...
